/* PlexusIRCD IRCD functions
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 *
 * $Id: plexus.c 433 2005-07-26 16:58:24Z drstein $
 *
 */

#include "denora.h"
#include "plexus.h" 

IRCDVar myIrcd[] = {
    {"PleXusIRCd 2.0+", 	    /* ircd name */
     "+oaiSR",                  /* operserv mode */
     1,                         /* Vhost  */
     0,                         /* Supports SGlines     */
     0,                         /* sgline sql table */
     1,                         /* Supports SQlines     */
     0,                         /* sqline sql table */
     0,                         /* Supports SZlines     */
     1,                         /* Has exceptions +e    */
     0,                         /* vidents              */
     0,                         /* NICKIP               */
     1,                         /* VHOST ON NICK        */
     0,                         /* +f                   */
     0,                         /* +L                   */
     0,		                    /* +f Mode                          */
     0,                         /* +L Mode                          */
     NULL,                      /* CAPAB Chan Modes             */
     0,                         /* We support TOKENS */
     1,                         /* TOKENS are CASE Sensitive */
     0,                         /* TIME STAMPS are BASE64 */
     1,                         /* +I support */
     0,                         /* SJOIN ban char */
     0,                         /* SJOIN except char */
     IRC_UMODE_h,               /* umode for vhost */
     0,                         /* owner */
     0,                         /* protect */
     1,                         /* halfop */
     "abcdfghilknoprswxyzRS",
     "beIacilkmnpstMNORZ",
     0,
     0,
     'h',
     0,
     0,
     0,
     1, 
     0,
     0,
     'b',
     'e',
     'I',
     0,
     1,
     NULL,
     0},
};

IRCDCAPAB myIrcdcap[] = {
    {
     0,                         /* NOQUIT       */
     0,                         /* TSMODE       */
     0,                         /* UNCONNECT    */
     0,                         /* NICKIP       */
     0,                         /* SJOIN        */
     CAPAB_ZIP,                 /* ZIP          */
     0,                         /* BURST        */
     CAPAB_TS5,                 /* TS5          */
     0,                         /* TS3          */
     0,                         /* DKEY         */
     0,                         /* PT4          */
     0,                         /* SCS          */
     CAPAB_QS,                  /* QS           */
     CAPAB_UID,                 /* UID          */
     CAPAB_KNOCK,               /* KNOCK        */
     0,                         /* CLIENT       */
     0,                         /* IPV6         */
     0,                         /* SSJ5         */
     0,                         /* SN2          */
     0,                         /* TOKEN        */
     0,                         /* VHOST        */
     0,                         /* SSJ3         */
     0,                         /* NICK2        */
     0,                         /* UMODE2       */
     0,                         /* VL           */
     0,                         /* TLKEXT       */
     0,                         /* DODKEY       */
     0,                         /* DOZIP        */
     0, 0, 0}
};

unsigned long myumodes[128] = {
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused, Unused, Horzontal Tab */
    0, 0, 0,                    /* Line Feed, Unused, Unused */
    0, 0, 0,                    /* Carriage Return, Unused, Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused */
    0, 0, 0,                    /* Unused, Unused, Space */
    0, 0, 0,                    /* ! " #  */
    0, 0, 0,                    /* $ % &  */
    0, 0, 0,                    /* ! ( )  */
    0, 0, 0,                    /* * + ,  */
    0, 0, 0,                    /* - . /  */
    0, 0,                       /* 0 1 */
    0, 0,                       /* 2 3 */
    0, 0,                       /* 4 5 */
    0, 0,                       /* 6 7 */
    0, 0,                       /* 8 9 */
    0, 0,                       /* : ; */
    0, 0, 0,                    /* < = > */
    0, 0,                       /* ? @ */
    0, 0, 0,                    /* A B C */
    0, 0, 0,                    /* D E F */
    0, 0, 0,                    /* G H I */
    0, 0, 0,                    /* J K L */
    0, 0, 0,                    /* M N O */
    0, 0, IRC_UMODE_R,              /* P Q R */
    IRC_UMODE_S, 0, 0,              /* S T U */
    0, 0, 0,                    /* V W X */
    0,                          /* Y */
    0,                          /* Z */
    0, 0, 0,                    /* [ \ ] */
    0, 0, 0,                    /* ^ _ ` */
    IRC_UMODE_a, IRC_UMODE_b, 0,        /* a b c */
    IRC_UMODE_d, 0, 0,              /* d e f */
    0, IRC_UMODE_h, IRC_UMODE_i,        /* g h i */
    0, 0, IRC_UMODE_l,              /* j k l */
    IRC_UMODE_g, IRC_UMODE_n, IRC_UMODE_o,  /* m n o */
    IRC_UMODE_p, 0, 0,                    /* p q r */
    0, 0, IRC_UMODE_u,              /* s t u */
    0, IRC_UMODE_w, IRC_UMODE_x,        /* v w x */
    0,                          /* y */
    0,                          /* z */
    0, 0, 0,                    /* { | } */
    0, 0                        /* ~  */
};


char myCsmodes[128] = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    0,
    0,
    0, 0, 0,
    'h',
    0, 0, 0, 0,
    0,

    'v', 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    'o', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

CMMode myCmmodes[128] = {
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, 
    {NULL, NULL},                     /* A */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* BCD */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* EFG */
    {NULL, NULL},                     /* H */
    {add_invite, del_invite},   /* I */
    {NULL, NULL},                     /* J */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* KLM */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* NOP */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* QRS */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* TUV */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* WXY */
    {NULL, NULL},                     /* Z */
    {NULL, NULL}, {NULL, NULL},             /* (char 91 - 92) */
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL},     /* (char 93 - 95) */
    {NULL, NULL},                     /* ` (char 96) */
    {NULL, NULL},                     /* a (char 97) */
    {add_ban, del_ban},         /* b */
    {NULL, NULL}, {NULL, NULL},             /* cd */
    {add_exception, del_exception},
    {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
};


CBMode myCbmodes[128] = {
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0},
    {0, 0},                        /* A */
    {0, 0},                        /* B */
    {0, 0},                        /* C */
    {0, 0},                        /* D */
    {0, 0},                        /* E */
    {0, 0},                        /* F */
    {0, 0},                        /* G */
    {0, 0},                        /* H */
    {0, 0},                        /* I */
    {0, 0},                        /* J */
    {0, 0},                        /* K */
    {0, 0},                        /* L */
    {IRCD_CMODE_M, NULL},            /* M */
    {IRCD_CMODE_N, NULL},            /* N */
    {IRCD_CMODE_O, NULL},            /* O */
    {0, 0},                        /* P */
    {0, 0},                        /* Q */
    {IRCD_CMODE_R, NULL},            /* R */
    {0, 0},                        /* S */
    {0, 0},                        /* T */
    {0, 0},                        /* U */
    {0, 0},                        /* V */
    {0, 0},                        /* W */
    {0, 0},                        /* X */
    {0, 0},                        /* Y */
    {IRCD_CMODE_Z, NULL},            /* Z */
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {IRCD_CMODE_a, NULL},            /* a */
    {0, 0},                        /* b */
    {IRCD_CMODE_c, NULL},            /* c */
    {0, 0},                        /* d */
    {0, 0},                        /* e */
    {0, 0},                        /* f */
    {0, 0},                        /* g */
    {0, 0},                        /* h */
    {IRCD_CMODE_i, NULL},            /* i */
    {0, 0},                        /* j */
    {IRCD_CMODE_k, set_key},         /* k */
    {IRCD_CMODE_l, set_limit},       /* l */
    {IRCD_CMODE_m, NULL},
    {IRCD_CMODE_n, NULL},
    {0, 0},                        /* o */
    {IRCD_CMODE_p, NULL},
    {0, 0},                        /* q */
    {0, 0},
    {IRCD_CMODE_s, NULL},
    {IRCD_CMODE_t, NULL},
    {0, 0},
    {0, 0},                        /* v */
    {0, 0},                        /* w */
    {0, 0},                        /* x */
    {0, 0},                        /* y */
    {0, 0},                        /* z */
    {0, 0}, {0, 0}, {0, 0}, {0, 0}
};

CBModeInfo myCbmodeinfos[] = {
    {'a', IRCD_CMODE_a, NULL},
    {'i', IRCD_CMODE_i, NULL},
    {'k', IRCD_CMODE_k, get_key},
    {'l', IRCD_CMODE_l, get_limit},
    {'m', IRCD_CMODE_m, NULL},
    {'n', IRCD_CMODE_n, NULL},
    {'p', IRCD_CMODE_p, NULL},
    {'s', IRCD_CMODE_s, NULL},
    {'t', IRCD_CMODE_t, NULL},
    {'M', IRCD_CMODE_M, NULL},
    {'N', IRCD_CMODE_N, NULL},
    {'O', IRCD_CMODE_O, NULL},
    {'R', IRCD_CMODE_R, NULL},
    {'Z', IRCD_CMODE_Z, NULL},
};

void plexus_cmd_notice(char *source, char *dest, char *buf)
{
    send_cmd(source, "NOTICE %s :%s", dest, buf);
}

void plexus_cmd_privmsg(char *source, char *dest, char *buf)
{
    send_cmd(source, "PRIVMSG %s :%s", dest, buf);
}

void plexus_cmd_serv_notice(char *source, char *dest, char *msg)
{
    send_cmd(source, "NOTICE $$%s :%s", dest, msg);
}

void plexus_cmd_serv_privmsg(char *source, char *dest, char *msg)
{
    send_cmd(source, "PRIVMSG $$%s :%s", dest, msg);
}

void plexus_cmd_global(char *source, char *buf)
{
    send_cmd(source ? source : ServerName, "OPERWALL :%s", buf);
}

int denora_event_sjoin(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    do_sjoin(source, ac, av);
    return MOD_CONT;
}

/*
 do_nick(const char *source, char *nick, char *username, char *host,
              char *server, char *realname, time_t ts, uint32 svid,
              uint32 ip, char *vhost, char *uid, int hopcount, char *modes)
*/
int denora_event_nick(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2) {
        User *user = do_nick(source, av[0], av[4], av[5], av[7], av[9],
                             strtoul(av[2], NULL, 10),
                             strtoul(av[8], NULL, 0), 0, av[6], NULL, strtoul(av[1], NULL, 0), av[3]);
        if (user)
            denora_set_umode(user, 1, &av[3]);
    } else {
        do_nick(source, av[0], NULL, NULL, NULL, NULL,
                strtoul(av[1], NULL, 10), 0, 0, NULL, NULL, 0, NULL);
    }
    return MOD_CONT;
}

int denora_event_topic(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
   do_topic(ac, av);
   return MOD_CONT;
}

int denora_event_tburst(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 5)
        return MOD_CONT;

    av[0] = av[1];
    av[1] = av[3];
    av[3] = av[4];
    do_topic(4, av);
    return MOD_CONT;
}

int denora_event_436(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac < 1)
        return MOD_CONT;

    m_nickcoll(av[0]);
    return MOD_CONT;
}

/* *INDENT-OFF* */
void moduleAddIRCDMsgs(void) {
    Message *m;
    
    m = createMessage("436",       denora_event_436); addCoreMessage(IRCD,m);
    m = createMessage("AWAY",      denora_event_away); addCoreMessage(IRCD,m);
    m = createMessage("INVITE",    denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("JOIN",      denora_event_join); addCoreMessage(IRCD,m);
    m = createMessage("KICK",      denora_event_kick); addCoreMessage(IRCD,m);
    m = createMessage("KILL",      denora_event_kill); addCoreMessage(IRCD,m);
    m = createMessage("MODE",      denora_event_mode); addCoreMessage(IRCD,m);
    m = createMessage("MOTD",      denora_event_motd); addCoreMessage(IRCD,m);
    m = createMessage("NICK",      denora_event_nick); addCoreMessage(IRCD,m);
    m = createMessage("PONG",      denora_event_pong); addCoreMessage(IRCD,m);
    m = createMessage("NOTICE",    denora_event_notice); addCoreMessage(IRCD,m);
    m = createMessage("PART",      denora_event_part); addCoreMessage(IRCD,m);
    m = createMessage("PASS",      denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("PING",      denora_event_ping); addCoreMessage(IRCD,m);
    m = createMessage("PRIVMSG",   denora_event_privmsg); addCoreMessage(IRCD,m);
    m = createMessage("QUIT",      denora_event_quit); addCoreMessage(IRCD,m);
    m = createMessage("SERVER",    denora_event_server); addCoreMessage(IRCD,m);
    m = createMessage("SQUIT",     denora_event_squit); addCoreMessage(IRCD,m);
    m = createMessage("TOPIC",     denora_event_topic); addCoreMessage(IRCD,m);
    m = createMessage("TBURST",    denora_event_tburst); addCoreMessage(IRCD,m);
    m = createMessage("USER",      denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("WALLOPS",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("WHOIS",     denora_event_whois); addCoreMessage(IRCD,m);
    m = createMessage("AKILL",     denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("GLOBOPS",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("GNOTICE",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("GOPER",     denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("RAKILL",    denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SILENCE",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SVSKILL",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SVSMODE",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SVSNICK",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SVSNOOP",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SQLINE",    denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("UNSQLINE",  denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("CAPAB",     denora_event_capab); addCoreMessage(IRCD,m);
    m = createMessage("SJOIN",     denora_event_sjoin); addCoreMessage(IRCD,m);
    m = createMessage("SVINFO",    denora_event_svinfo); addCoreMessage(IRCD,m);
    m = createMessage("EOB",       denora_event_eob); addCoreMessage(IRCD,m);
    m = createMessage("ADMIN",     denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("ERROR",     denora_event_error); addCoreMessage(IRCD,m);
    m = createMessage("SETHOST",   denora_event_sethost); addCoreMessage(IRCD,m);
    m = createMessage("SVSID",     denora_event_null); addCoreMessage(IRCD,m);
}

/* *INDENT-ON* */

void plexus_cmd_join(char *user, char *channel, time_t chantime)
{
    send_cmd(NULL, "SJOIN %ld %s + :%s", (long int) chantime, channel,
             user);

    if (AutoOp)
        send_cmd(ServerName, "MODE %s +o %s", channel, user);
}

/*
 * SVINFO
 *      parv[0] = sender prefix
 *      parv[1] = TS_CURRENT for the server
 *      parv[2] = TS_MIN for the server
 *      parv[3] = server is standalone or connected to non-TS only
 *      parv[4] = server's idea of UTC time
 */
void plexus_cmd_svinfo()
{
    send_cmd(NULL, "SVINFO 5 5 0 :%ld", (long int) time(NULL));
}

/* CAPAB */
/*
  QS     - Can handle quit storm removal
  EX     - Can do channel +e exemptions 
  CHW    - Can do channel wall @#
  LL     - Can do lazy links 
  IE     - Can do invite exceptions 
  EOB    - Can do EOB message
  KLN    - Can do KLINE message 
  GLN    - Can do GLINE message 
  HOPS   - can do half ops (+h)
  HUB    - This server is a HUB 
  AOPS   - Can do anon ops (+a) 
  UID    - Can do UIDs
  ZIP    - Can do ZIPlinks
  ENC    - Can do ENCrypted links 
  KNOCK  -  supports KNOCK 
  TBURST - supports TBURST
  PARA	 - supports invite broadcasting for +p
  ENCAP	 - ?
*/
void plexus_cmd_capab()
{
    send_cmd(NULL,
             "CAPAB :QS EX CHW IE EOB KLN GLN HOPS HUB KNOCK TBURST PARA");
}

void plexus_cmd_stats(char *sender, const char *letter, char *server)
{
    send_cmd(sender, "STATS %s %s", letter, server);
}

/* PASS */
void plexus_cmd_pass(char *pass)
{
    send_cmd(NULL, "PASS %s :TS", pass);
}

/* SERVER name hop descript */
void plexus_cmd_server(char *servname, int hop, char *descript)
{
    send_cmd(NULL, "SERVER %s %d :%s", servname, hop, descript);
}

void plexus_cmd_connect()
{
    char *hops;

    hops = sstrdup("0");
    me_server = do_server(NULL, ServerName, hops, ServerDesc, NULL);
    denora_free(hops);

    plexus_cmd_pass(RemotePassword);
    plexus_cmd_capab();
    plexus_cmd_server(ServerName, 1, ServerDesc);
    plexus_cmd_svinfo();
}

void plexus_cmd_bot_nick(char *nick, char *user, char *host, char *real,
                        char *modes)
{
    send_cmd(NULL, "NICK %s 1 %ld %s %s %s %s %s 0 :%s", nick,
             (long int) time(NULL), modes, user, host, "*", ServerName,
             real);
}

int denora_event_pong(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
  server_store_pong(source, time(NULL));
  return MOD_CONT;
}

void plexus_cmd_part(char *nick, char *chan, char *buf)
{
    if (buf) {
        send_cmd(nick, "PART %s :%s", chan, buf);
    } else {
        send_cmd(nick, "PART %s", chan);
    }
}

int denora_event_sethost(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    change_user_host(source, av[0]);
    return MOD_CONT;
}

int denora_event_ping(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac < 1)
        return MOD_CONT;
    plexus_cmd_pong(ac > 1 ? av[1] : ServerName, av[0]);
    return MOD_CONT;
}

int denora_event_away(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (!ac) {
       m_away(source, NULL);
    } else {
       m_away(source, av[0]);
    }
    return MOD_CONT;
}

int denora_event_kill(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2)
        return MOD_CONT;

    m_kill(source, av[0], av[1]);
    return MOD_CONT;
}

int denora_event_kick(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 3)
        return MOD_CONT;
    do_kick(source, ac, av);
    return MOD_CONT;
}

int denora_event_eob(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
    update_sync_state(source, 1);
    return MOD_CONT;
}

void plexus_cmd_eob()
{
    send_cmd(ServerName, "EOB");
}

void plexus_cmd_ping(char *server)
{
    send_cmd(ServerName, "PING %s :%s", ServerName, server);
}

int denora_event_join(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 1)
        return MOD_CONT;
    do_join(source, ac, av);
    return MOD_CONT;
}

int denora_event_motd(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
  m_motd(source);
  return MOD_CONT;
}

int denora_event_privmsg(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2)
        return MOD_CONT;
    m_privmsg(source, av[0], av[1]);
    return MOD_CONT;
}

int denora_event_part(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac < 1 || ac > 2)
        return MOD_CONT;
    do_part(source, ac, av);
    return MOD_CONT;
}

int denora_event_whois(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (source && ac >= 1) {
        m_whois(source, av[0]);
    }
    return MOD_CONT;
}

/* EVENT: SERVER */
int denora_event_server(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (!stricmp(av[1], "1")) {
        denora->uplink = sstrdup(av[0]);
        me_server->uplink = sstrdup(av[0]);
        do_server(source, av[0], av[1], av[2], NULL);
        return MOD_CONT;
    }
    do_server(source, av[0], av[1], av[2], NULL);
    return MOD_CONT;
}

int denora_event_squit(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2)
        return MOD_CONT;
    do_squit(av[0]);
    return MOD_CONT;
}

int denora_event_quit(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 1)
        return MOD_CONT;
    do_quit(source, ac, av);
    return MOD_CONT;
}

void plexus_cmd_mode(char *source, char *dest, char *buf)
{
    send_cmd(source, "MODE %s %s", dest, buf);
}

void plexus_cmd_nick(char *nick, char *name, const char *mode)
{
    send_cmd(NULL, "NICK %s 1 %ld %s %s %s %s %s 0 :%s", nick,
             (long int) time(NULL), mode, ServiceUser, ServiceHost,
             "*", ServerName, (name));
}

/* QUIT */
void plexus_cmd_quit(char *source, char *buf)
{
    if (buf) {
        send_cmd(source, "QUIT :%s", buf);
    } else {
        send_cmd(source, "QUIT");
    }
}

/* PONG */
void plexus_cmd_pong(char *servname, char *who)
{
    send_cmd(servname, "PONG %s", who);
}

/* SQUIT */
void plexus_cmd_squit(char *servname, char *message)
{
    send_cmd(NULL, "SQUIT %s :%s", servname, message);
}

int denora_event_mode(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac < 2)
        return MOD_CONT;

    if (*av[0] == '#' || *av[0] == '&') {
        do_cmode(source, ac, av);
    } else {
        Server *s;
        s = findserver(source);

        if (s && *av[0]) {
            do_umode(av[0], ac, av);
        } else {
            do_umode(source, ac, av);
        }
    }
    return MOD_CONT;
}

void plexus_cmd_351(char *source)
{
    send_cmd(ServerName, "351 %s Denora-%s %s :%s -- build #%s, compiled %s %s",
             source, denora->version, ServerName, ircd->name,
             denora->build, denora->date, denora->time);
}

/* Event: PROTOCTL */
int denora_event_capab(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    capab_parse(ac, av);
    return MOD_CONT;
}

/*
 * SVINFO
 *      parv[0] = sender prefix
 *      parv[1] = TS_CURRENT for the server
 *      parv[2] = TS_MIN for the server
 *      parv[3] = server is standalone or connected to non-TS only
 *      parv[4] = server's idea of UTC time
 */
int denora_event_svinfo(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    /* currently not used but removes the message : unknown message from server */
    return MOD_CONT;
}

int denora_event_error(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac >= 1) {
       alog(LOG_ERROR, "ERROR: %s", av[0]);
    }
    return MOD_CONT;
}

void plexus_cmd_version(char *server)
{
    send_cmd(s_StatServ, "VERSION %s", server);
}

void plexus_cmd_motd(char *sender, char *server)
{
    send_cmd(sender, "MOTD %s", server);
}

int denora_event_notice(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2) {
        return MOD_CONT;
    }
    m_notice(source, av[0], av[1]);
    return MOD_CONT;
}

void plexus_cmd_ctcp(char *source, char *dest, char *buf)
{
    send_cmd(source, "NOTICE %s :\1%s \1", dest, buf);
}

void moduleAddIRCDCmds() {
    pmodule_cmd_nick(plexus_cmd_nick);
    pmodule_cmd_mode(plexus_cmd_mode);
    pmodule_cmd_bot_nick(plexus_cmd_bot_nick);
    pmodule_cmd_notice(plexus_cmd_notice);
    pmodule_cmd_privmsg(plexus_cmd_privmsg);
    pmodule_cmd_serv_notice(plexus_cmd_serv_notice);
    pmodule_cmd_serv_privmsg(plexus_cmd_serv_privmsg);
    pmodule_cmd_351(plexus_cmd_351);
    pmodule_cmd_quit(plexus_cmd_quit);
    pmodule_cmd_pong(plexus_cmd_pong);
    pmodule_cmd_join(plexus_cmd_join);
    pmodule_cmd_part(plexus_cmd_part);
    pmodule_cmd_global(plexus_cmd_global);
    pmodule_cmd_squit(plexus_cmd_squit);
    pmodule_cmd_connect(plexus_cmd_connect);
    pmodule_cmd_eob(plexus_cmd_eob);
    pmodule_cmd_ctcp(plexus_cmd_ctcp);
    pmodule_cmd_version(plexus_cmd_version);
    pmodule_cmd_stats(plexus_cmd_stats);
    pmodule_cmd_motd(plexus_cmd_motd);
    pmodule_cmd_ping(plexus_cmd_ping);
}

int DenoraInit(int argc, char **argv) 
{
  if (denora->protocoldebug) {
        protocol_debug(NULL, argc, argv);
  }
	moduleAddAuthor("Denora");
    moduleAddVersion("$Id: plexus.c 433 2005-07-26 16:58:24Z drstein $");
    moduleSetType(PROTOCOL);

    pmodule_ircd_version("PleXusIRCd 2.0+");
    pmodule_ircd_cap(myIrcdcap);
    pmodule_ircd_var(myIrcd);
    pmodule_ircd_cbmodeinfos(myCbmodeinfos);
    pmodule_ircd_cbmodes(myCbmodes);
    pmodule_ircd_cmmodes(myCmmodes);
    pmodule_ircd_csmodes(myCsmodes);
    pmodule_ircd_umodes(myumodes);
	pmodule_ircd_useTSMode(0);
    pmodule_irc_var(IRC_PLEXUS);
	pmodule_oper_umode(IRC_UMODE_o);
    moduleAddIRCDCmds();
    moduleAddIRCDMsgs();
    return MOD_CONT;
}


