
/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: statserv.c 401 2005-07-09 16:41:08Z trystan $
 *
 */

#include "denora.h"

/*************************************************************************/

void ss_init(void)
{
    
}

/*************************************************************************/

/* Main StatServ routine. */

void statserv(User * u, char *buf)
{
    char *cmd, *buf2;
    char *s;
    int freeme = 0;

    buf2 = sstrdup(buf);
    cmd = strtok(buf, " ");

    SET_SEGV_LOCATION();

    if (!cmd) {
        denora_free(buf2);
        return;
    } else if (stricmp(cmd, "\1PING") == 0) {
        if (!(s = strtok(NULL, ""))) {
            s = sstrdup("");
            freeme = 1;
        }
        denora_cmd_ctcp(s_StatServ, u->nick, "PING %s", s);
        if (freeme) {
           denora_free(s);
        }
    } else {
        SET_SEGV_LOCATION();
        /* CTCP VERSION returns as MESSAGE we can't have StatServ
           saying that they are denied for their clients reply */
        if (stricmp(cmd, "\1VERSION")) {
            if (!is_oper(u)) {
                notice_lang(s_StatServ, u, ACCESS_DENIED);
                return;
            }
        }
        /* do not show the login password in the logchannel */
        /* there is a special log message in do_login */
        if (stricmp(cmd, "LOGIN") != 0) {
            alog(LOG_NORMAL, "%s: %s: %s", s_StatServ, u->nick, buf2);
        }
        mod_run_cmd(s_StatServ, u, STATSERV, cmd);
    }
    denora_free(buf2);
}

