
/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: users.c 441 2005-07-30 16:05:33Z dukepyrolator $
 *
 */

#include "denora.h"

User *userlist[1024];
Uid *uidlist[1024];

/*************************************************************************/

/* add modes to a nickid */
void sql_do_usermodes(const char *nick, char *modes)
{
    int atleastone = 0;
    char db[MAX_SQL_BUF];
    char tmp[14] = "mode_XX=\"X\", ";
    char buf[1000];
    int nickid = 0;
    char *sqlnick, *sql;

    sqlnick = sstrdup(nick);
    sql = rdb_escape(sqlnick);
    SET_SEGV_LOCATION();
    nickid = db_getnick(sql);

    if (!nickid) {
        return;
    }

    *db = '\0';
    *buf = '\0';

    SET_SEGV_LOCATION();

    snprintf(buf, sizeof(buf), "UPDATE %s SET ", UserTable);
    strcpy(db, buf);
    while (*modes) {
        switch (*modes) {
        case '+':
            tmp[9] = 'Y';
            break;
        case '-':
            tmp[9] = 'N';
            break;
        default:
            if (!strchr(ircd->usermodes, *modes)) {
                alog(LOG_DEBUG, langstr(ALOG_UKNOWN_USER_MODE), *modes,
                     inbuf);
            } else {
                atleastone = 1;
                tmp[5] = ((*modes >= 'a') ? 'l' : 'u');
                tmp[6] = tolower(*modes);
                strcat(db, tmp);
            }
            break;
        }
        modes++;
    }
    if (atleastone) {
        sprintf(&db[strlen(db) - 2], " WHERE nickid=%d", nickid);
        rdb_query(db);
    }
    denora_free(sqlnick);
    denora_free(sql);
}

/*************************************************************************/

void sql_do_swhois(char *user, char *msg)
{
    int nickid;
    SET_SEGV_LOCATION();

    if (!denora->do_sql) {
        return;
    }

    user = rdb_escape(user);
    msg = rdb_escape(msg);
    nickid = db_getnick_unsure(user);
    if (nickid == -1) {
        alog(LOG_NONEXISTANT, langstr(ALOG_SWHOIS_ERROR), user);
    } else
        rdb_query("UPDATE %s SET swhois=\'%s\' WHERE nickid=%d",
                  UserTable, msg, nickid);
    denora_free(user);
    denora_free(msg);
}

/*************************************************************************/

/* NICK (new nick) */
void sql_do_nick(char *nick, char *username, char *host,
                 char *server, char *realname, time_t ts,
                 char *vhost, int hopcount, char *ipchar,
                 const char *country_code, const char *country_name)
{
    int servid;
    int add = 1;
    int nickid;
    User *u;
    char *nick_;

    SET_SEGV_LOCATION();

    nick_ = rdb_escape(nick);
    username = rdb_escape(username);
    host = rdb_escape(host);
    server = rdb_escape(server);
    if (ircd->vhost) {
        vhost = rdb_escape(vhost);
    }
    realname = rdb_escape(realname);
    servid = db_getserver(server);

    SET_SEGV_LOCATION();

    if (UserCacheTime && ((nickid = db_checknick(nick_)) != -1)) {
        SET_SEGV_LOCATION();
        if (ircd->vhost) {
            rdb_query
                ("UPDATE %s SET nick=\'%s\', hopcount=%d, nickip=\'%s\', countrycode=\'%s\', country=\'%s\', realname=\'%s\', hostname=\'%s\', hiddenhostname=\"%s\", username=\'%s\', connecttime=FROM_UNIXTIME(%d), servid=%d, server=\'%s\', lastquit=NULL, online=\'Y\', away=\'N\', awaymsg=\'\' WHERE nickid=%d",
                 UserTable, nick_, hopcount, ipchar, country_code,
                 country_name, realname, host, vhost, username, ts, servid,
                 server, nickid);
        } else {
            rdb_query
                ("UPDATE %s SET nick=\'%s\', hopcount=%d, nickip=\'%s\', countrycode=\'%s\', country=\'%s\', realname=\'%s\', hostname=\'%s\', username=\'%s\', connecttime=FROM_UNIXTIME(%d), servid=%d, server=\'%s\', lastquit=NULL, online=\'Y\', away=\'N\', awaymsg=\'\' WHERE nickid=%d",
                 UserTable, nick_, hopcount, ipchar, country_code,
                 country_name, realname, host, username, ts, servid,
                 server, nickid);
        }
        add = 0;
    }
    if (add) {
        SET_SEGV_LOCATION();
        if (ircd->vhost) {
            rdb_query
                ("INSERT INTO %s (nick, hopcount, nickip, realname, hostname, hiddenhostname, username, connecttime, servid, server, countrycode, country) VALUES(\'%s\',%d,\'%s\', \'%s\',\'%s\',\'%s\',\'%s\',FROM_UNIXTIME(%d),%d, \'%s\', \'%s\', \'%s\')",
                 UserTable, nick_, hopcount, ipchar, realname, host, vhost,
                 username, ts, servid, server, country_code, country_name);
        } else {
            rdb_query
                ("INSERT INTO %s (nick, hopcount, nickip, realname, hostname, username, connecttime, servid, server, countrycode, country) VALUES(\'%s\',%d,\'%s\', \'%s\',\'%s\',\'%s\',FROM_UNIXTIME(%d),%d, \'%s\', \'%s\', \'%s\')",
                 UserTable, nick_, hopcount, ipchar, realname, host,
                 username, ts, servid, server, country_code, country_name);
        }
    }
    SET_SEGV_LOCATION();

    nickid = db_getnick(nick_);
    if (nickid) {
        u = finduser(nick);
        u->sqlid = nickid;
    }

    if (UserCacheTime)
        db_cleanuser();
    SET_SEGV_LOCATION();

    denora_free(nick_);
    denora_free(username);
    denora_free(host);
    denora_free(server);
    SET_SEGV_LOCATION();

    if (ircd->vhost) {
        denora_free(vhost);
    }
    denora_free(realname);
    SET_SEGV_LOCATION();
}

/*************************************************************************/

/* NICK (nick change) */
void sql_do_nick_chg(char *newnick, char *oldnick)
{
    int nickid;

    SET_SEGV_LOCATION();

    newnick = rdb_escape(newnick);
    oldnick = rdb_escape(oldnick);
    /* the target nickname might already exist if caching is enabled */
    if (UserCacheTime && (strcasecmp(newnick, oldnick))
        && ((nickid = db_checknick(newnick)) != -1)) {
        /* In this case, we don't keep a record of the old nick. It would be :
         * - technically difficult, because we'd have to make a copy of the record
         * - dangerous, because it would provide an easy way to fill up the DB */
        rdb_query("DELETE from %s WHERE nickid=%d", UserTable, nickid);
    }
    /* we update the nickname */
    rdb_query("UPDATE %s SET nick=\'%s\' WHERE nick=\'%s\'",
              UserTable, newnick, oldnick);
    denora_free(newnick);
    denora_free(oldnick);
}

/*************************************************************************/

/* Allocate a new User structure, fill in basic values, link it to the
 * overall list, and return it.  Always successful.
 */

static User *new_user(const char *nick)
{
    User *user, **list;

    SET_SEGV_LOCATION();
    user = scalloc(sizeof(User), 1);
    if (!nick)
        nick = "";
    strscpy(user->nick, nick, NICKMAX);
    list = &userlist[USERHASH(user->nick)];
    user->next = *list;
    if (*list)
        (*list)->prev = user;
    *list = user;
    return user;
}

/*************************************************************************/

/* Change the nickname of a user, and move pointers as necessary. */

static void change_user_nick(User * user, const char *nick)
{
    User **list;
    int is_same;

    /* Sanity check to make sure we don't segfault */
    if (!user || !nick || !*nick) {
        return;
    }

    SET_SEGV_LOCATION();

    is_same = (!stricmp(user->nick, nick) ? 1 : 0);

    if (user->prev) {
        user->prev->next = user->next;
    } else {
        userlist[USERHASH(user->nick)] = user->next;
    }
    if (user->next) {
        user->next->prev = user->prev;
    }
    user->nick[1] = 0;          /* paranoia for zero-length nicks */
    strscpy(user->nick, nick, NICKMAX);
    list = &userlist[USERHASH(user->nick)];
    user->next = *list;
    user->prev = NULL;
    if (*list) {
        (*list)->prev = user;
    }
    *list = user;
}

/*************************************************************************/

/* Change the (virtual) hostname of a user. */

void change_user_host(char *source, char *host)
{
    User *user;
    char *sqluser, *msg;

    if (ircd->p10) {
        user = find_byuid(source);
        if (!user) {
            user = finduser(source);
        }
    } else {
        user = finduser(source);
    }
    if (!user) {
        alog(LOG_NONEXISTANT,
             "user: SETHOST/CHGHOST for nonexistent user %s", source);
        return;
    }

    SET_SEGV_LOCATION();

    if (user->vhost)
        denora_free(user->vhost);
    user->vhost = sstrdup(host);

    alog(LOG_DEBUG, langstr(ALOG_VHOST_FOR), user->nick, host);

    if (denora->do_sql) {
        sqluser = rdb_escape(user->nick);
        msg = rdb_escape(user->vhost);
        SET_SEGV_LOCATION();
        if (ircd->vhostchar && ircd->vhostchar2) {
            rdb_query
                ("UPDATE %s SET mode_l%c=\'Y\', mode_l%c=\'Y\', hiddenhostname=\'%s\' WHERE nickid=%d",
                  UserTable, ircd->vhostchar, ircd->vhostchar2, msg,
                  db_getnick(sqluser));
        } else if (ircd->vhostchar && !ircd->vhostchar2) {
            rdb_query
                ("UPDATE %s SET mode_l%c=\'Y\', hiddenhostname=\'%s\' WHERE nickid=%d",
                  UserTable, ircd->vhostchar, msg, db_getnick(sqluser));
        } else {
            rdb_query
                ("UPDATE %s SET hiddenhostname=\'%s\' WHERE nickid=%d",
                  UserTable, msg, db_getnick(sqluser));
        }
        denora_free(msg);
        denora_free(sqluser);
    }
}

/*************************************************************************/

/* Change the realname of a user. */

void change_user_realname(char *source, char *realname)
{
    User *user;
    char *sqlnick;
    char *msg;

    SET_SEGV_LOCATION();

    user = finduser(source);
    if (!user) {
        alog(LOG_NONEXISTANT,
             "user: SETNAME/CHGNAME for nonexistent user %s", source);
        return;
    }

    if (user->realname)
        denora_free(user->realname);
    user->realname = sstrdup(realname);

    alog(LOG_DEBUG, langstr(ALOG_REALNAME_FOR), user->nick, realname);

    if (denora->do_sql) {
        sqlnick = rdb_escape(user->nick);
        msg = rdb_escape(user->realname);
        SET_SEGV_LOCATION();
        rdb_query
            ("UPDATE %s SET realname=\'%s\' WHERE nickid=%d",
                UserTable, msg, db_getnick(sqlnick));
        denora_free(msg);
        denora_free(sqlnick);
    }
}

/*************************************************************************/

/* Change the username of a user. */

void change_user_username(char *source, char *username)
{
    User *user;
    char *sqluser, *msg;

    SET_SEGV_LOCATION();

    user = finduser(source);
    if (!user) {
        alog(LOG_NONEXISTANT,
             "user: SETIDENT/CHGIDENT for nonexistent user %s", source);
        return;
    }

    if (user->username)
        denora_free(user->username);
    user->username = sstrdup(username);

    alog(LOG_DEBUG, langstr(ALOG_USERNAME_FOR), user->nick, username);

    if (denora->do_sql) {
        sqluser = rdb_escape(user->nick);
        msg = rdb_escape(user->username);
        SET_SEGV_LOCATION();
        rdb_query
            ("UPDATE %s SET username=\'%s\' WHERE nickid=%d",
                UserTable, msg, db_getnick(sqluser));
        denora_free(msg);
        denora_free(sqluser);
    }
}

/*************************************************************************/

/* Remove and free a User structure. */

void delete_user(User * user)
{
    struct u_chanlist *c, *c2;

    SET_SEGV_LOCATION();

    if (!user) {
        return;
    }
    send_event(EVENT_USER_LOGOFF, 1, user->nick);
    del_current_user(user->server);

    alog(LOG_EXTRADEBUG, "debug: delete_user() called");
    if (is_oper(user)) {
        del_oper_count(user);
    }

    if (user->country_code) {
        tld_update(user->country_code);
    }
    if (user->ctcp) {
        ctcp_update(user->ctcp);
    }
    alog(LOG_EXTRADEBUG, "debug: delete_user(): free user data");
    denora_free(user->username);
    denora_free(user->host);
    if (user->vhost) {
        denora_free(user->vhost);
    }
    denora_free(user->ip);
    denora_free(user->ctcp);
    denora_free(user->country_code);
    denora_free(user->country_name);
    denora_free(user->sgroup);
    denora_free(user->realname);
    alog(LOG_EXTRADEBUG, "debug: delete_user(): remove from channels");
    c = user->chans;
    while (c) {
        c2 = c->next;
        chan_deluser(user, c->chan);
        denora_free(c);
        c = c2;
    }
    alog(LOG_EXTRADEBUG, "debug: delete_user(): free founder data");

    moduleCleanStruct(&user->moduleData);

    alog(LOG_EXTRADEBUG, "debug: delete_user(): delete from list");
    if (user->prev)
        user->prev->next = user->next;
    else
        userlist[USERHASH(user->nick)] = user->next;
    if (user->next)
        user->next->prev = user->prev;
    alog(LOG_EXTRADEBUG, "debug: delete_user(): free user structure");
    denora_free(user);
    alog(LOG_EXTRADEBUG, "debug: delete_user() done");
}

/*************************************************************************/

/* Find a user by nick.  Return NULL if user could not be found. */

User *finduser(const char *nick)
{
    User *user;

    SET_SEGV_LOCATION();

    if (!nick || !*nick) {
        alog(LOG_DEBUG, "Error: finduser() called with NULL values");
        return NULL;
    }

    alog(LOG_EXTRADEBUG, "debug: finduser(%p)", nick);
    user = userlist[USERHASH(nick)];
    while (user && stricmp(user->nick, nick) != 0)
        user = user->next;
    alog(LOG_EXTRADEBUG, "debug: finduser(%s) -> 0x%p", nick,
         (void *) user);
    return user;
}

/*************************************************************************/

/* Iterate over all users in the user list.  Return NULL at end of list. */

static User *current;
static int next_index;

User *firstuser(void)
{
    next_index = 0;

    SET_SEGV_LOCATION();

    while (next_index < 1024 && current == NULL)
        current = userlist[next_index++];
    alog(LOG_EXTRADEBUG, "debug: firstuser() returning %s",
         current ? current->nick : "NULL (end of list)");
    if (current) {
        return current;
    } else {
        return NULL;
    }
}

/*************************************************************************/

User *nextuser(void)
{
    SET_SEGV_LOCATION();

    if (current)
        current = current->next;
    if (!current && next_index < 1024) {
        while (next_index < 1024 && current == NULL)
            current = userlist[next_index++];
    }
    alog(LOG_EXTRADEBUG, "debug: nextuser() returning %s",
         current ? current->nick : "NULL (end of list)");
    return current;
}

/*************************************************************************/

User *find_byuid(const char *uid)
{
    User *u, *next;

    u = first_uid();
    while (u) {
        next = next_uid();
        if (u && u->uid) {
            if (!stricmp(uid, u->uid)) {
                return u;
            }
        }
        u = next;
    }
    return NULL;
}

/*************************************************************************/

User *first_uid(void)
{
    next_index = 0;
    while (next_index < 1024 && current == NULL) {
        current = userlist[next_index++];
    }
    alog(LOG_EXTRADEBUG, "debug: first_uid() returning %s %s",
         current ? current->nick : "NULL (end of list)",
         current ? current->uid : "");
    return current;
}

/*************************************************************************/

User *next_uid(void)
{
    if (current)
        current = current->next;
    if (!current && next_index < 1024) {
        while (next_index < 1024 && current == NULL)
            current = userlist[next_index++];
    }
    alog(LOG_EXTRADEBUG, "debug: next_uid() returning %s %s",
         current ? current->nick : "NULL (end of list)",
         current ? current->uid : "");
    return current;
}

/*************************************************************************/

Uid *new_uid(const char *nick, char *uid)
{
    Uid *u, **list;

    u = scalloc(sizeof(Uid), 1);
    if (!nick || !uid) {
        return NULL;
    }
    strscpy(u->nick, nick, NICKMAX);
    list = &uidlist[UIDHASH(u->nick)];
    u->next = *list;
    if (*list)
        (*list)->prev = u;
    *list = u;
    u->uid = sstrdup(uid);
    return u;
}

/*************************************************************************/

Uid *find_uid(const char *nick)
{
    Uid *u;
    int i;

    for (i = 0; i < 1024; i++) {
        for (u = uidlist[i]; u; u = u->next) {
            if (!stricmp(nick, u->nick)) {
                return u;
            }
        }
    }
    return NULL;
}

/*************************************************************************/

Uid *find_nickuid(const char *uid)
{
    Uid *u;
    int i;

    for (i = 0; i < 1024; i++) {
        for (u = uidlist[i]; u; u = u->next) {
            if (!stricmp(uid, u->uid)) {
                return u;
            }
        }
    }
    return NULL;
}

/*************************************************************************/

/* Handle a server NICK command. */

User *do_nick(const char *source, char *nick, char *username, char *host,
              char *server, char *realname, time_t ts, uint32 svid,
              uint32 ip, char *vhost, char *uid, int hopcount, char *modes)
{

    User *user;
    char ipbuf[16];
    struct in_addr addr;
    GeoIP *gi = NULL;
    char *ipchar;
    Server *s;
    const char *country_code;
    const char *country_name;

    SET_SEGV_LOCATION();
    *ipbuf = '\0';


    if (!*source) {
        if (!LargeNet) {
            gi = GeoIP_new(GEOIP_STANDARD);
            country_code = GeoIP_country_code_by_name(gi, host);
            country_name = GeoIP_country_name_by_name(gi, host);
            if (!country_name) {
                country_name = "Unknown";
            }
            if (!country_code) {
                country_code = "??";
            }
        } else {
            country_name = "Unknown";
            country_code = "??";
        }
        if (!LargeNet) {
            if (ircd->nickip && ip) {
                if (ircd->p10) {
                    addr.s_addr = ntohl(ip);
                } else {
                    addr.s_addr = htonl(ip);
                }
                ntoa(addr, ipbuf, sizeof(ipbuf));
                ipchar = sstrdup(ipbuf);
            } else {
                ipchar = host_resolve(host);
            }
        } else {
            ipchar = sstrdup("Host Resolve disabled in config");
        }
        if (!ipchar) {
            ipchar = sstrdup("0.0.0.0");
        }

        s = findserver(server);

        /* Allocate User structure and fill it in. */
        user = new_user(nick);
        user->username = sstrdup(username);
        user->host = sstrdup(host);
        if (s) {
            user->server = (s ? s : NULL);
        } else {
            alog(LOG_DEBUG, "Problem!!! server is %s", server);
            sleep(5);
        }
        user->realname = sstrdup((realname ? realname : ""));
        user->timestamp = ts;
        user->my_signon = time(NULL);
        user->vhost = (vhost ? sstrdup(vhost) : sstrdup(host));
        if (uid) {
            user->uid = sstrdup(uid);   /* p10 stuff */
        } else {
            user->uid = NULL;
        }
        user->admin = 0;        /* 0 by default, winner, eh? */
        SET_SEGV_LOCATION();
        if (ipchar) {
            user->ip = sstrdup(ipchar);
        } else {
            user->ip = sstrdup("0.0.0.0");
        }

        user->cstats = 0;
        user->sgroup = NULL;
        user->language = StatsLanguage;

        SET_SEGV_LOCATION();
        user->country_code = sstrdup(country_code);
        user->country_name = sstrdup(country_name);
        if (!LargeNet) {
            do_tld(user->country_name, user->country_code);
        }
        if (gi) {
            GeoIP_delete(gi);
        }
        if (denora->do_sql) {
            sql_do_nick(nick, username, host, server, realname, ts,
                        user->vhost, hopcount, ipchar, country_code,
                        country_name);
            if (modes) {
                sql_do_usermodes(nick, modes);
            }
        }
        SET_SEGV_LOCATION();
        add_current_user(s);

        user->svid = (svid == (uint32) ts ? svid : 1);
        send_event(EVENT_NEWNICK, 1, user->nick);
        SET_SEGV_LOCATION();
        if (!LargeNet) {
            if (CTCPUsers && stricmp(s_StatServ, user->nick)) {
                denora_cmd_privmsg(s_StatServ, user->nick, "VERSION");
            }
        }
        if (ipchar) {
            denora_free(ipchar);
        }
    } else {
        user = finduser(source);

        if (!user) {
            return NULL;
        }
        user->timestamp = ts;

        if (denora->do_sql) {
            sql_do_nick_chg(nick, user->nick);
        }

        if (stricmp(nick, user->nick)) {
            change_user_nick(user, nick);
            send_event(EVENT_CHANGE_NICK, 2, source, nick);
        } else {
            user->my_signon = time(NULL);
        }

    }
    SET_SEGV_LOCATION();

    return user;
}

/*************************************************************************/

/* Handle a MODE command for a user.
 *	av[0] = nick to change mode for
 *	av[1] = modes
 */

void do_umode(const char *source, int ac, char **av)
{
    User *user;

    SET_SEGV_LOCATION();

    user = finduser(source);
    if (!user) {
        alog(LOG_NONEXISTANT, langstr(ALOG_UMODE_NONEXISTANT),
             av[1], source, merge_args(ac, av));
        return;
    }

    denora_set_umode(user, ac - 1, &av[1]);
    if (denora->do_sql)
        sql_do_usermodes(source, av[1]);
}

/*************************************************************************/

void do_svsumode(int ac, char **av)
{
    User *user;

    SET_SEGV_LOCATION();

    user = finduser(av[0]);
    if (!user) {
        alog(LOG_NONEXISTANT, langstr(ALOG_UMODE_NONEXISTANT),
             av[1], av[0], merge_args(ac, av));
        return;
    }

    denora_set_umode(user, ac - 1, &av[1]);
    if (ircdcap->tsmode) {
        if (denora->capab & ircdcap->tsmode || UseTSMODE) {
            if (denora->do_sql)
                sql_do_usermodes(av[0], av[2]);
        }
    } else {
        if (denora->do_sql)
            sql_do_usermodes(av[0], av[1]);
    }
}

/*************************************************************************/

/* Handle a UMODE2 command for a user.
 *	av[0] = modes
 */

void do_umode2(const char *source, int ac, char **av)
{
    User *user;

    SET_SEGV_LOCATION();

    user = finduser(source);
    if (!user) {
        alog(LOG_NONEXISTANT, langstr(ALOG_UMODE_NONEXISTANT),
             av[0], source, merge_args(ac, av));
        return;
    }
    denora_set_umode(user, ac, &av[0]);
    if (denora->do_sql)
        sql_do_usermodes(source, av[0]);
}

/*************************************************************************/

/* Handle a QUIT command.
 *	av[0] = reason
 */

void do_quit(const char *source, int ac, char **av)
{
    User *user;
    char *nick, *sqlnick;

    SET_SEGV_LOCATION();

    if (ircd->p10) {
        user = find_byuid(source);
        if (!user) {
            user = finduser(source);
        }
    } else if (UseTS6 && ircd->ts6) {
        user = find_byuid(source);
        if (!user) {
            user = finduser(source);
        }
    } else {
        user = finduser(source);
    }
    if (!user) {
        alog(LOG_NONEXISTANT, "user: QUIT from nonexistent user %s: %s",
             source, merge_args(ac, av));
        return;
    }
    alog(LOG_DEBUG, "debug: %s quits", user->nick);

    nick = sstrdup(user->nick);
    delete_user(user);
    if (denora->do_sql) {
        sqlnick = rdb_escape(nick);
        db_removenick(sqlnick);
        if (UserCacheTime) {
            db_cleanuser();
        }
        denora_free(sqlnick);
    }
    denora_free(nick);
}

/*************************************************************************/

/* Handle a KILL command.
 *	av[0] = nick being killed
 *	av[1] = reason
 */

void do_kill(char *nick, char *msg)
{
    User *user;
    user = finduser(nick);

    SET_SEGV_LOCATION();

    if (!user) {
        alog(LOG_NONEXISTANT, "debug: KILL of nonexistent nick: %s", nick);
        return;
    }
    alog(LOG_DEBUG, "debug: %s killed: %s", nick, msg);
    nick = sstrdup(user->nick);
    delete_user(user);
    if (denora->do_sql) {
        nick = rdb_escape(nick);
        db_removenick(nick);
        if (UserCacheTime) {
            db_cleanuser();
        }
    }
    denora_free(nick);
}

/*************************************************************************/

/* Is the given nick an oper? */

int is_oper(User * user)
{
    SET_SEGV_LOCATION();

    if (user) {
        SET_SEGV_LOCATION();
        return (user->mode & denora_get_oper_mode());
    } else {
        SET_SEGV_LOCATION();
        return 0;
    }
}

/*************************************************************************/

/**
 * Get the vhost for the user, if set else return the host, on ircds without
 * vhost this returns the host
 * @param u user to get the vhost for
 * @return vhost
 */
char *common_get_vhost(User * u)
{
    SET_SEGV_LOCATION();

    if (!u) {
        return NULL;
    }
    if (ircd->vhostmode) {
        if (u->mode & ircd->vhostmode) {
            return u->vhost;
        } else {
            return u->host;
        }
    } else {
        return u->host;
    }
}

/*************************************************************************/

/**
 * Get the vident for the user, if set else return the ident, on ircds without
 * vident this returns the ident
 * @param u user to get info the vident for
 * @return vident
 */
char *common_get_vident(User * u)
{
    SET_SEGV_LOCATION();

    if (!u) {
        return NULL;
    }
    if (ircd->vhostmode) {
        if (u->mode & ircd->vhostmode) {
            if (u->vident) {
                return u->vident;
            } else {
                return u->username;
            }
        } else {
            return u->username;
        }
    } else {
        return u->username;
    }
}

/*************************************************************************/


